clear
clc
pack

H=21.5;Pmax=18;ang=35*pi/180;
temps_energie=4000;                % Temps  partir duquel l'nergie reue est mesure
global jour
jour=355;

disp([' jour= ' num2str(jour)]);

 pas_mini=0.02;pas_maxi=0.05; % Pas de la simulation,  choisir avec soin, ce sont les valeurs recommandes

% **************************************************************************************************************


%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$
                     
                                    latitude_injection= 70;                                      % En degrs

%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$

% **************************************************************************************************************


%   pas_mini=0.02;pas_maxi=0.1; Pas de la simulation,  choisir avec soin, ce sont les valeurs recommandes

 
% **************************************************************************************************************


global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace tau vitesse_angul_mini

global instant_injection T Ta Tu pulse periode period_sans period_reg

global KPD_laurens FPD_laurens mom_max_bobine cpl_max_roue J_ROUE J pas_mini pas_maxi

global gain_PD_laurens K_PD_laurens F_PD_laurens consigne_tangage KB KRG KFG Hy zenith

global Pmax H ang temps_energie rayon_orbital inclinaison

% ******** Donnes de la rgulation mixte de LAURENS acquisition grossire ******************
%                 PAR REGULATION PD SUR L'ANGLE DE ROTATION QUATERNION

 KRG=0.12*2;

 KFG=7*2/100;

 period_sans=200;

 period_reg=1000;
 
% ************* Donnes de la rgulation mixte de LAURENS type 0, en TUMBLING  ******************
%                                        sans rappel sur la rotation transversale
 zenith=-1;             % Valeur 1 pour un pointage zenth et -1 pour un pointage nadir
  
 KPD_laurens=1.6e-5;    %  Coefficient de rappel sur champ de consigne

 FPD_laurens=8.4e-3;    %  Coefficient de rappel sur drive du champ de consigne


 % ****************************************************************

vitesse_angul_mini=2e-3;     % Vitesse angulaire au dessous de laquelle on passe au mode fin

angle_quater_maxi=10*pi/180; % Test d'arrt de l'acquisition grossire en rd ( 10 ou autre )

angles_cardan=5;             % Test d'arrt de l'acquisition grossire (5 ou autre )          

T=5;Ta=0.1;Tu=4.9;pulse=0; % Nouvel essai

K_poinsot=1;              % Permet par la mise  0 de simuler un mouvement de poinsot, sans moment externe
                          % ce qui permet de vrifier une bonne partie de la simulation ( intgration)

% Gain de la matrice de gain pour la drive de B


% Nombre de points du trac

 points_trace=42000;

 points_reduits=40000*4;

% *************************** LIMITATIONS PHYSIQUES DES COMPOSANTS************************


 mom_max_bobine=0.2;      % Am  puissance maxi d'une bobine
 
 cpl_max_roue=4e-6;       % Nm   couple maxi dlivr par la roue
 couple_max_roue=4e-6;    % Pour la premire roue que j'ai essaye

% ************************************************************************************
% Ce fichier initialise la simulation regderiv.m ou regdesat.m ou reg_derb.m ou boussol0.m ....

%  *******************   Matrice d''inertie satellite  *******************************

Ir=32e-3;It=36e-3;Il=22e-3;Irt=5.8e-5;Irl=3e-4;Itl=4e-3;

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% ******************  Caractristiques de l'orbite du satellite ***********************

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

latitude_injection=latitude_injection*pi/180;                          % 70 convertis en rd

instant_injection=asin(sin( latitude_injection)/sin(inclinaison))/vitesse_rotation;
 
instant_injection=fix(instant_injection);              % Instant injection calcul  1 seconde prs
                                                       % aprs survol quateur suppos  t=0 seconde

deltaT=0;   % Retard orbital de base, pour d'autres valeurs cliquer directement le choix dans la simulation ( cases vertes )
                             %   **********  VALEURS INITIALES   ******

% Initialisation en vitesses (rd/s), trs proches de l'quilibre znith

v_roulis0=0.0001;
v_tangage0=0.0005;              
v_lacet0=-0.0001;

% Initialisation en position (rd), trs proches de l'quilibre znith

roulis0=0.01*0; tangage0=-0.005*0;lacet0=0.03*0;


                             % ***************** DONNEES PERTURBATIONS********************


mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;

                             % **************** DONNEES ROUE ET CONSIGNES  *********************
J_ROUE=3.2e-5;      		       % Moment d'inertie de la roue en mkg
J=3.2e-5;         		               % Moment d'inertie de la roue en mkg

 vitesseroue=100*zenith;   		       % Roue  en dbut de rgulation, elle pourra ensuite voluer
 
 rotation_initiale=100*zenith;               % Vitesse de rotation initiale de la roue  3900 t/mn

 rotation_maximale= 360;               % Vitesse de rotation maximale de la roue environ 3600 t/mn

 Hy=J_ROUE*vitesseroue;

 consigne_tangage=0;
 consigne_lacet=pi*(1-sign(Hy))/2;       % C'est le retournement satellite avec -y align sur Y
 consigne_roulis=0;                      %   Valeurs de consigne de l'angle de tangage  atteindre, en radian 

                            % ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end



% *****************************  Rcupration des valeurs finales   ***********************************
%load init_GP.mat;

%temps_fin_tumb=init_acqGP(2,length(init_acqGP));              % Scalaire, valeur finale du temps detumbling

%initpqrQ_final=init_acqGP(3:9,length(init_acqGP));            % Vecteur ligne 

%initpqrQ_final=initpqrQ_final';                               % Transposition pour avoir des donnes horizontales


% ******************   Initialisation de la vitesse de la roue par la simulation prcdente  *************

%load vit_roue.mat;

% rotation_initiale=vit_roue_rd_s(2,length(vit_roue_rd_s));       % Valeur initiale de la vitesse de la roue

%rotation_initiale=vit_roue_rd_s(2);

%vitesseroue=rotation_initiale;









