function y=inv_quat(Pmat);

% Fonction qui calcule le quaternion Q qui donne la matrice de passage Pmat de XYZ  xyz,

% Pmat est la transpose de la matrice de rotation M

% NB : Calculs en provenance de Marmottes

% Cette fonction est notamment utile pour le calcul des conditions initiales du quaternion

M=Pmat';

s0=M(1,1)+M(2,2)+M(3,3);

if s0>-0.1
  q0=0.5*(1+s0)^0.5;
  q1=(M(2,3)-M(3,2))/4/q0;q2=(M(3,1)-M(1,3))/4/q0;q3=(M(1,2)-M(2,1))/4/q0;
end
s1=M(1,1)-M(2,2)-M(3,3);
if s1>-0.1
  q1=0.5*(1+s1)^0.5;
  q0=-(M(2,3)-M(3,2))/4/q1;q2=(M(1,2)+M(2,1))/4/q1;q3=(M(3,1)+M(1,3))/4/q1;
end
s2=-M(1,1)+M(2,2)-M(3,3);
if s2>-0.1
  q2=0.5*(1+s2)^0.5;
  q0=(M(3,1)-M(1,3))/4/q2;q1=(M(1,2)+M(2,1))/4/q2;q3=(M(3,2)+M(2,3))/4/q2;
end
s3=-M(1,1)-M(2,2)+M(3,3);  
if s3>-0.1
  q3=0.5*(1+s3)^0.5;
  q0=(M(1,2)-M(2,1))/4/q3;q1=(M(1,3)+M(3,1))/4/q3;q2=(M(3,2)+M(2,3))/4/q3;
end


y=[q0 q1 q2 q3];

end