function y=quat_err(Q1,Q2);

% voir le site -->  https://tel.archives-ouvertes.fr/tel-00585525v1/document
%                            la page 30 

%      ***************************************************
%      * Calcul du quaternion d'erreur Qe=Inv(Q1)*Q2     *
%      * quaternion qui transforme le repre de consigne *
%      * Rc associ  Q1 en repre de position actuelle  *
%      *             R associ  Q2                      *
%      ***************************************************

% Q ou Q2 est le quaternion de l'attitude actuelle reprsentant la rotation qui
% transforme le repre Ro de rfrence en repre mobile satellite R
%                       il entre comme vecteur colonne

% Qc ou Q1 est le quaternion de l'attitude de consigne souhaite reprsentant la 
% rotation qui transforme le repre de rfrence Ro en repre de consigne Rc
%                       il entre en vecteur colonne

% L'quivalent du signal d'erreur est le quaternion Qe=Inv(Q1)*Q2
% ------------------------------------------------------------------------------------------------

Q=Q2;Q=Q/norm(Q);                           % Quaternion actuel ***  normalis par prcaution
Qc=Q1;Qc=Qc/norm(Qc);                       % Quaternion de consigne  *** normalis par prcaution

% ------------------------------------------------------------------------------------------------

% y est le quaternion d'erreur, celui de la rotation faisant passer de R  Rc
%                       il sortira en vecteur colonne

% ******Calcul de la matrice 4X4 nomm Mat qui facilite le calcul Qe=Mat(fonction de Q1 )*Q  *****

Mat(1,1)=Qc(1);
Mat(2:4,1)=-Qc(2:4);                        % Qc En colonne
Mat(1,2:4)=Qc(2:4)';                        % Qc transform en ligne

RotQc234=[0  -Qc(4) Qc(3);                  % Matrice associe au produit vectoriel Qc en tte
        Qc(4) 0 -Qc(2);
               -Qc(3) Qc(2) 0];

Mat(2:4,2:4)=Qc(1)*eye(3)-RotQc234;         % Matrice carre 3X3

% ****** Qbarre=[Qc(1) -Qc(2) -Qc(3) -Qc(4)]';Q_erreur=prodquat(Qbarre,Q)' **** Vrification ****

% -------------------------  Sortie du quaternion d'erreur  -------------------------
y=Mat*Q;

% --------------------------------  Fin programme  ---------------------------------- 
