function y=soleil(u);

% ***********************************************************************
% La connaissance de H et jour, dans l'espace de travail est indispensable
% ***********************************************************************

global H jour rayon_orbital vitesse_rotation inclinaison periode_orbitale

tps=u;

% Fonction qui retourne:
%	-1 si le satellite est clair par le soleil
%        et 0 dans le cas contraire

% u est le temps comme vecteur d'entre, celui de la simulation 
%	- H heure au noeud ascendant
%	- jour est le jour de l'anne civile
%	- tps est le temps orbital mesur depuis le passage au noeud acendant

% ***********************************************************************************

% Unitaire soleil

teta=15*(12-H)*pi/180;                                        % Longitude nodale du soleil ( / Xn ), en radians

delta=23.45*sin(2*pi/365*(284+jour))*pi/180;                  % Dclinaison en radians formule de Fletcher

Us=[cos(delta)*cos(teta) cos(delta)*sin(teta) sin(delta)];    % Us en axes XnYnZn

% Rayon vecteur satellite en axes XnYnZn

angle=vitesse_rotation*tps;

rayon_vecteur=rayon_orbital*[cos(angle) sin(angle)*cos(inclinaison) sin(angle)*sin(inclinaison)];

% Norme du produit vectoriel

XX=[rayon_vecteur Us];

pv=prodvect(XX);

pv=norm(pv);

pv=(pv<=6378000);                                  % Condition 1

% Produit scalaire

ps=rayon_vecteur*Us';

ps=(ps<=0);                                         % Condition 2


% ------------------ Conclusion ------------------

y(1)=~(pv & ps);                      % Sortie 1 ou 0


end    % Fin programme


