clear
clc

global Ir It Il Irl Itl Irt Asat Inv_Asat etat_init vitesse_rotation altitude points_trace
global temps energie_zero mom_mgn_max q_ref teta_ref
global K_roulis K_lacet K_tangage KP_roue KD_roue h_ref C_max omega_roue_max omega_roue_ref Jroue
global K_Q1 K_Q3 temps_debut_simu etat_init K_aero 
global angles_hauts angles_bas vitesses_hautes marche


% *********************  CHOIX DES CONSTANTES CAS PARTICULIERS  ***********************
K_perturbation=1;      % 0 sans perturbation  1 avec perturbations
K_commande=1;          % 0 sans commande  1 avec commande
K_inertie=1;           % 0 diagonale   1 avec matrice relle
K_revolution=0;        % 0 pour une matrice d'inertie quelconque 1 pour une matrice de rvolution autour de y
K_repos=0;             % 0 pour le cas gnral et 1 pour le repos total
K_petit_cone=0;        % 0 pour le cas gnral et 1 pour un cne de Poinsot trs rduit
K_CPL_MGN_NUL=1;       % 0 Pour liminer les magntocoupleurs
K_CPL_ROUE_NUL=1;      % 0 Pour liminer le couple roue
K_ROUE_CSTE=1;         % 0 Pour supprimer le couplage gyroscopique roue-satellite
K_aero=1;              % 0 pour supprimer la perturbation arodynamique
%mem_reg=1;             % Souvenir de la mise en rgulation mem_reg=1 en marche sinon 0
% **************************************************************************************
angles_hauts=3;      % degrs
angles_bas=2;        % degrs   
marche=[1 1]';     

% ***************** Caractristiques de l'orbite du satellite **********************

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3); % pulsation orbitale en rd/s
inclinaison=98.7*pi/180;
periode_orbitale=2*pi/vitesse_rotation;

% ----------------  CAS DE CASAA_SAT -------------
% Les axes orbitaux sont:
%	X tangent  la trajectoire
%	Y normal au plan orbital et de sens contraire  la rotation orbitale
%	Z orient Nadir
%
% Les axes satellite sont en situation idale avec pointage Nadir:
%	x tangent  la trajectoire, la trajectoire est //  x cot X+
%	y normal au plan orbital et de sens contraire  la rotation orbitale
%	z orient Nadir, les antennes sont cot Z+
%
% On change simplement le signe de la vitesse de rotation orbitale
% Et surtout on change le signes de BY et BZ
% -------------------------------------------------------
vitesse_rotation=-vitesse_rotation;
epsilon=-1; 
% -------------------------------------------------------
% -------------------- Choix des gains ------------------

% ***** Magntocoupleurs *******

K_roulis=1.4e4;        % Ne pas trop s'loigner de 1.37e4 et
K_lacet=1.25e4;        %                                     1.25e4   
K_tangage=1e4;                 

% ************ Roue ************
%   Valeurs donnant un couple roue de l'ordre de 10-7 mN et une vitesse roue oscillant autour de -600 T/mn

KP_roue=1e-3;            
KD_roue=50;                    

% *******  Valeurs techniques de rfrence concernant la roue ********

C_max=6e-3;                          % N-m
omega_roue_max=6500*2*pi/60;         % En rd/s   -->  6500 Tours/mn
omega_roue_ref=epsilon*600*2*pi/60;  % En rd/s   -->  -600 Tours/mn
Jroue=2.2037e-5;                     % kgm
q_ref=epsilon*3.2*pi/180;            % -3.2 pour la vitesse finale autour de y
teta_ref=0;
h_ref=Jroue*omega_roue_ref;          % h_ref=-1.38e-3  Nms en version fac          
 

% ********************   Saturation des magntocoupleurs  *******************

mom_mgn_max=0.2; % Moment magntique maximum  ne pas dpasser

% Nombre de points du trac

 points_trace=40000;

% *****************  Choix de la matrice d''inertie satellite ( suivant essais ) ********************
%	x=r=roulis
%	y=t=tangage
%	z=l=lacet

if K_inertie==0
  % Cas matrice diagonale
  Ir=22e-3;It=25e-3;Il=10e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

if K_revolution==1
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
  Ir=3.7e-3;It=10.6e-3;Il=10.3e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

% *************** Asat ****************

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

Inv_Asat=inv(Asat);

% [V,D]=eig(Asat),

% Asat =[0.0220         0         0
%                0    0.0251         0
%                     0         0    0.0099]


%   **********  VALEURS INITIALES   ***********

% Initialisation en vitesses (rd/s)

v_roulis0=0.03;
v_tangage0=0.02;
v_lacet0=0.01;

% Initialisation petites vitesses

v_roulis0=0.02;
v_tangage0=0.002;
v_lacet0=-0.01;


% Initialisation en position (rd)  ( quelques degrs )

roulis0=0.05;
tangage0=-0.05;
lacet0=0.05;

if K_repos==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0;v_tangage0=0.1;v_lacet0=0;
end

if K_petit_cone==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ et trs petite vitesse transverse
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0.00524;v_tangage0=0.1;v_lacet0=0;
end

% ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;


% cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********
% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   
energie_zero=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]';

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial

Q=inv_quat(Pmat);

qt00=Q(1);qt10=Q(2);qt20=Q(3);qt30=Q(4);

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)];

% Rcupration du vecteur d'tat et du temps de la rgulation tumble.m
% --------------------------------------------------------------------
load InitFin.mat

etat_init_fin=init_sca_fin(2:8,length(init_sca_fin))';  % Matrice ligne

temps_debut_simu=init_sca_fin(1,length(init_sca_fin));  % Scalaire

% --------------------------------------------------------------------

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

% q0=Q(1);q1=Q(2);q2=Q(3);q3=Q(4);

% roulis00=atan2(2*(q0*q1+q2*q3),q0^2-q1^2-q2^2+q3^2),

% tangage00=asin(2*(q0*q2-q1*q3)),

% lacet00=atan2(2*(q0*q3+q2*q1),q0^2+q1^2-q2^2-q3^2),

% ecart=roulis00-roulis0+tangage00-tangage0+lacet00-lacet0,

T_couplage=2*pi/abs(h_ref)*(Ir*Ir)^0.5;

end







