clear                                  % Pur viter les problmes de "cache" dans Matlab
clc                                    % idem
points_trace=50000;                    % Nombre de points du trac, attention  la saturation mmoire
mom_mgn_max=0.2;                       % Am Moment magntique maximum  ne pas dpasser

%                                    ************************************
%                                    *   Pour CASAANEW/TUMBLE00.M       *
%                                    ************************************

% ************************** Choix des seuils de basculement tumbling vers mode fin ***********************

q_max=0.01;                 % Vitesse angulaire (rd/s) en dessous de laquelle le contrle fin peut commencer
tangage_max=20;             % Valeur (  ) en dessous de laquelle le contrle fin peut commencer
ecart_max_Y=5;              % Valeur en () de l'alignement y sur Y souhait
ecart_max_Z=5;              % Valeur en () de l'alignement y sur Y souhait

% *********************************  DECLARATIONS DES VARIABLES GLOBALES **********************************

global Ir It Il Irl Itl Irt Asat Inv_Asat etat_init vitesse_rotation altitude points_trace 
global energie_zero mom_mgn_max K_beta K_stab q_ref temps_phase1 temps_phase2 temps_phase3 temps_stop 
global K_steyn_sans_signe coeff_A Jroue omega_roue_ref
global q_max tangage_max ecart_max_Y ecart_max_Z

% *********************************** Caractristiques de l'orbite du satellite ****************************
altitude_orbite=817;		                             % altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);             % Pulsation orbitale en rd/s
inclinaison=98.7*pi/180;
periode_orbitale=2*pi/vitesse_rotation;                      % En secondes

% **********************************  CONSTANTES DES CAS PARTICULIERS  **************************************
K_perturbation=1;      % 0 sans perturbation  1 avec perturbations
K_commande=1;          % 0 sans commande  1 avec commande
K_inertie=1;           % 0 diagonale   1 avec matrice relle
K_revolution=0;        % 0 pour une matrice d'inertie quelconque 1 pour une matrice de rvolution autour de y
K_repos=0;             % 0 pour le cas gnral et 1 pour le repos total
K_petit_cone=0;        % 0 pour le cas gnral et 1 pour un cne de Poinsot trs rduit
K_steyn_sans_signe=1;  % 0 si on optimise avec le signe de la puissance, sinon 1 avec la loi la plus simple

% ************************************** REGULATION DETUMBLING **********************************************

% -------------------------------------   Gains des rgulations ------------------------------------------

K_beta=15;                      % Constantes de la rgulation de detumbling seul   
                                %    K_beta est relati  a vitesse beta_prime
K_stab=3;                       %    K_stab est relatif  la mise en spin  vitesse de rfrence fixe
                               

% ** NB :( K_beta=20 donne une longue saturation )
%    en dbut de detumbling On pourrait attaquer le detumnling avec des gains moindres
% ** REMARQUES ( suite aux essais ) 
%		K_beta=10;K_stab=8;   Bon rsultat mais amplitude de 20
%		K_beta=15;K_stab=8 AB mais vitesses angulaires transverses moins amorties
%		K_beta=15;K_stab=5;  Semble excellent reste les modulations !!
%		Ces modulations disparaissent avec une matrice de rvolution
%		Sans perturbation l'angle (Y,y) vaut 1778 au bout de 20000 secondes --> Alignement parfait


% -----------------------------------  CAS DE CASAA_SAT DERNIERE VERSION  -----------------------------------
% Les axes orbitaux choisis sont:
%	X tangent  la trajectoire
%	Y normal au plan orbital et de sens contraire  la rotation orbitale-
%	Z orient Nadir
%
% Les axes satellite sont en situation idale avec un pointage Nadir:
%	x tangent  la trajectoire, la trajectoire est //  x cot X+
%	y normal au plan orbital et de sens contraire  la rotation orbitale
%	z orient Nadir, les antennes sont cot Z+
%
% NB : pour moi,  partir des simulations o Z tait orient znith, il suffit de change simplement
%    le signe de la vitesse de rotation orbitale
%    Et surtout on change le signes de BY et BZ, composantes du champ magntique
% ----------------------------------------------------------------------------------------------------------
vitesse_rotation=-vitesse_rotation;
epsilon=-1;              % 1 si on veut qref et omega_roue_ref >0 et - 1 pour les 2 valeurs ngatives
% -----------------------------------------------------------------------------------------------------------

% **************************  Valeurs techniques de rfrence concernant la roue ****************************
C_max=6e-3;                           % N-m  A prciser ??????????????????????????????????????????????????
omega_roue_max=6500*2*pi/60;          % En rd/s   -->  6500 Tours/mn
omega_roue_ref=epsilon*2000*2*pi/60;  % En rd/s   -->  -2000 Tours/mn  au lieu de -600 t/mn
             
Jroue=2.0292e-6;                      % kgm au lieu de 2.2037e-5
q_ref=epsilon*1*pi/180;               % -1 pour la vitesse finale autour de y, au lieu de -3.2 %/s
teta_ref=0;

% ----------------------------------- Concernant les gains de la rgulation ---------------------------------------

K_roulis=25;     
K_lacet=25;
K_tangage=240;  

% *****************************************************
KP_roue=2e-7*200;     
KD_roue=5e-5*50;


% $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$    TIMING DES TROIS REGULATIONS ENCHANEES  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

temps_phase1=25000;                    % Dure de la phase detumbling avec K_beta et beta_ptime
temps_phase2=3000;                     % Top de dmarrage de la mise en spin  vitesse prdtermine
temps_phase3=8000;temps_stop=1000;     % Top de dclenchement du despin et dure de cette opration qui doit:
                                       %	1 - annuler le moment cintique du nanosatellite
                                       %	2 - porter la vitesse roue  sa vitesse de croisire

% ----------------------- Loi du couple roue d'annulation du moment cintique C=A(t-t0)  ---------------------
% NB : J'ai choisi une loi de monte du couple linaire de manire  avoir une progressivit qui vite une
%      percussion. Toute loi est acceptable.
%      C=A(t-t0)

coeff_A=omega_roue_ref*2*Jroue/temps_stop^2;

% ***************************************  Gomtrie du nanosatellite ****************************************

% ---------------------------------------  x=r=roulis   y=t=tangage     z=l=lacet  ---------------------------

%                   Matrice d''inertie satellite suivant divers cas particuliers et cas gnral

if K_inertie==0
  % Cas matrice diagonale
  Ir=22e-3;It=25e-3;Il=10e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

if K_revolution==1
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

% *************************************  MATRICE D'INERTIE  *************************************************

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

Inv_Asat=inv(Asat);                               % Pouir viter un calcul d'inversion ( 2 fois )

% [V,D]=eig(Asat),                                % Vrification de valeurs propres

% Asat =[0.0220         0         0
%                0    0.0251         0
%                     0         0    0.0099]


%   **********************************************  VALEURS INITIALES   ***********************************
%                                           Donnes pour des angles de Cardan 

% Initialisation en vitesses faibles (rd/s)

v_roulis0=0.06;
v_tangage0=0.05;
v_lacet0=0.01;

% Initialisation grandes vitesses ( rd/s )
% v_roulis0=0.5;v_tangage0=0.55;v_lacet0=-0.45;

% Initialisation vitesses moyennes
v_roulis0=0.1;v_tangage0=0.2;v_lacet0=-0.15;


% Initialisation en position (rd)

roulis0=0.5;
tangage0=-0.55;
lacet0=-0.45;

% Initialisation particulire de vrification
% roulis0=0;
% tangage0=pi/2;
% lacet0=0;

if K_repos==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0;v_tangage0=0.1;v_lacet0=0;
end

if K_petit_cone==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ et trs petite vitesse transverse
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0.00524;v_tangage0=0.1;v_lacet0=0;
end

%                           ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes depuis 2/11/2015 *************************

mom_magn_res=0.001;                              %  Moment magntique rsiduel en Am, au lieu de 0.01 Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3);  % Direction unitaire /satellite du moment rsiduel
                                                 % NB : il faudrait essayer une direction alatoire

cpl_aero1=0;
cpl_aero2=-7.8e-9;                               % COUPLE AERODYNAMIQUE au lieu de 3.6e-8 Nm
cpl_aero3=0;

%                                 **********************************************
%                                 *   Pression photonique non prise en compte  *
%                                 **********************************************
%                                 *    Gradient de gravit pris en compte      *
%                                 *      directement dans les quations        *
%                                 **********************************************


% ******************************* CALCULS D'INITIALISATION DU VECTEUR D'ETAT *****************************

%                 Rotation absolue compose de la rotation par rapport au repre orbital
%                         et de la rotation  vitesse_rotation porte par Y ou -Y
%                                   suivant le choix du repre orbital

%                                 CALCULS AVEC LES ANGLES DE CARDAN                        
vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   
energie_zero=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]'; % Peut servir pour les vrifications des cas particuliers

% ------------------  Calcul du quaternion initial connaissant les angles initiaux  -----------------------

%           Matrice de passage P de la base fixe XYZ  la base satellite xyz,  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

%                          determinant=det(Pmat),            % ************* Bien vrifi ***********

% Calcul du quaternion initial, utilisant la fonction y=inv_quat(u)

Q=inv_quat(Pmat);                                             % Quaternion initial

qt00=Q(1);qt10=Q(2);qt20=Q(3);qt30=Q(4);

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);          % Normalisation du quaternion 

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)];                  % Initialise l'intgrateur


end

% ***************************************  FIN FIN FIN FIN   *****************************************





